﻿using System;

using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        //创建Socket
        private static TcpListener server;
        public List<TcpClient> clients = new List<TcpClient>();
        static void Main(string[] args)
        {
            ////////////////////////////////////////////////////////////////////////////////
            //  SendString();//作为客户端时发送数据 客户端代码
            /////////////////////////////////////////////////////////////////////////////////////
            ///作为服务端时接受数据   服务端代码
            //定义接受的端口号
            Console.WriteLine("少壮不努力，老大徒伤悲，如果年轻的时候如此努力，结果会怎样？");
            Console.WriteLine(".............................................................");
            Console.WriteLine("请输入IP地址，注意格式正确！");
            string ip = Console.ReadLine();
            Console.WriteLine("请输入监控端口号！");
            int port =int.Parse(Console.ReadLine());
           // int port = 8080;
            //地址解析
            //IPAddress iPAddress = IPAddress.Parse("192.168.10.241");
            IPAddress iPAddress = IPAddress.Parse(ip);
            IPEndPoint ipPOrt = new IPEndPoint(iPAddress, port);
            //开启一个TcpListener用来监听端口
            server = new TcpListener(ipPOrt);
            server.Start();
            // Console.WriteLine("少壮不努力，老大徒伤悲，如果年轻的时候如此努力，结果会怎样？");
            Console.WriteLine("IP地址 "+ip+"       监听端口号 "+port);
            Console.WriteLine("启动监听成功！");
            server.BeginAcceptTcpClient(new AsyncCallback(DoAcceptTcpclient), server);
            Console.ReadKey();
            /////////////////////////////////////////////////////////////////////////////////////
//
        }
        public static void SendString()
        {
            //
            //要发送的数据
            string str = "hello world";
            //发送的IP地址
            string StrIP = "127.0.0.1";
            //发送的端口号
            string StrPort = "8080";
            //将发送的数据转换成btye格式
            byte[] SendData = Encoding.UTF8.GetBytes(str);
            //IP地址转换
            IPAddress ipadress = IPAddress.Parse(StrIP);
            int port = int.Parse(StrPort);
            //新建TCP客户端
            TcpClient tcpclient = new TcpClient();
            //提供网络访问的基础流的数据
            NetworkStream stream = null;
            try
            {
                //建立连接
                tcpclient.Connect(ipadress, port);
                //返回用于发送和接收数据的 System.Net.Sockets.NetworkStream。
                stream = tcpclient.GetStream();
                //数据写入并发送
                stream.WriteAsync(SendData, 0, str.Length);
                stream.Close();
                tcpclient.Close();
            }
            catch (Exception ex)
            {
                Console.WriteLine("连接失败！");
                Console.ReadKey();
                throw ex;

            }
        }
        private static void DoAcceptTcpclient(IAsyncResult result)
        {
            //获取监听事件，处理客户端请求
            TcpListener listerer = (TcpListener)result.AsyncState;
            TcpClient client = listerer.EndAcceptTcpClient(result);
            List<TcpClient> clients = new List<TcpClient>();
            clients.Add(client);
            Console.WriteLine("客户端建立完成，id{0}", client.Client.RemoteEndPoint.ToString());
            //开一个线程，将处理客户端接受到的数据ParameterizedThreadStart和Start放的都是object
            Thread thread = new Thread(new ParameterizedThreadStart(ReceiveMessageFromClient));
            //开启线程
            thread.Start(client);
           // server.BeginAcceptTcpClient(new AsyncCallback(DoAcceptTcpclient), server);
        }
        private static void ReceiveMessageFromClient(object reciveClient)
        {
            byte[] result = new byte[1024];
            //将reciveClient实体装换成TCPClient类
            TcpClient client = reciveClient as TcpClient;
            if (client == null)
            {
                Console.WriteLine("client error");
                return;
            }
            while (true)
            {
                try
                {

                    NetworkStream stream = client.GetStream();
                    Console.WriteLine("wait a moment");
                    //读取数据的长度，并放到result结果中
                    int num = stream.Read(result, 0, result.Length);
                    if (num != 0)
                    {
                        //将结果转换成str类型
                        string str = Encoding.UTF8.GetString(result, 0, num);
                        Console.WriteLine("数据长度：{0}，数据内容：{1}", num, str);
                    }
                    else
                    {
                        Console.WriteLine("客户端关闭");
                        break;
                    }
                }
                catch (Exception ex)
                {

                    throw ex;
                }
            }
        }

    }
}
